<template>
    <div>
        <v-list two-line>
            <template v-if="!loading">
                <v-list-item
                    v-for="(item, index) in items"
                    :key="index"
                >
                    <v-list-item-avatar tile size="48">
                        <v-img src="images/visa.png"></v-img>
                    </v-list-item-avatar>

                    <v-list-item-content>
                        <v-list-item-title>•••• •••• •••• {{ item.last4 }}</v-list-item-title>
                        <v-list-item-subtitle>
                            Expires {{ item.exp_month | shortMonth }} {{ item.exp_year }}
                        </v-list-item-subtitle>
                    </v-list-item-content>
                    <v-list-item-action>
                        <v-btn
                            @click="onDelete(item.id)"
                            class="text-capitalize"
                            color="error"
                            text
                        >
                            <v-icon left>mdi-delete</v-icon>
                            {{ $t('delete') }}
                        </v-btn>
                    </v-list-item-action>
                </v-list-item>
            </template>

            <div
                v-else
                class="d-flex justify-center"
            >
                <v-progress-circular indeterminate color="primary"></v-progress-circular>
            </div>
        </v-list>

        <v-dialog
            v-model="dialog"
            persistent
            width="300"
        >
            <v-card>
                <v-card-title class="title primary white--text">
                    {{ $t('remove_', [$t('payment_methods')]) }}
                </v-card-title>

                <v-card-text class="subtitle">
                    {{ $t('payment_methods_warning') }}
                </v-card-text>

                <v-divider></v-divider>

                <v-card-actions class="justify-center">
                    <v-btn
                        :loading="loading"
                        @click="dialog = false"
                        color="primary"
                        text
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        :loading="loading"
                        @click="remove"
                        color="primary"
                        text
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
    export default {
        name: 'PaymentMethods',
        props: {
            items: {
                type: Array,
                default: () => []
            },
            loading: {
                type: Boolean,
                default: false
            },
            value: {
                require: true,
                default: false
            }
        },
        computed: {
            dialog: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },
        data: () => ({
            selected: ''
        }),
        methods: {
            onDelete(id) {
                this.selected = id;
                this.dialog = true;
            },

            remove() {
                this.dialog = true;
                this.$emit('remove', this.selected);
                this.selected = '';
            }
        }
    }
</script>

<style scoped>

</style>
